#include<stdlib.h>
#include<string.h>
#include "simglo.h"
#include "clusim.h"

long sseg (long i, long j)
/* Berechnung des Segmentes der smatrix */
{
  if (i>=j)
    return((i*(i+1))/2+j);
  else
    return((j*(j+1))/2+i);
}

void tabausgabe(void)
/* Ausgabe der Durchschnittstabelle der g2-Cluster */
/* Benoetigt globale Variable n, gz2, ad, invz, heapco,
out, zad, scz2, convstop, smatrix */
/* Benoetigt Funktion sseg */
{
long i, j, gn, start=0, zaehler=0;

/* TZ */ printf ("Calculation of cluster similarity table\n");
  fprintf(out,"\n* Cluster intersection table *\nTotal number of standard level-clusters: %ld\n",scz2);
  fprintf(out,"Number of points in the intersection of standard level-clusters no.\n\n");
  do
  {
    fprintf(out,"No.  Total  ");
    if (n>999)
                  fprintf(out," ");
    if (n>9999)
		  fprintf(out," ");
	 for (i=start; (i<scz2 && i<start+10); ++i)
	 {
		if (i<9)
		  fprintf(out," ");
		if (i<99)
		  fprintf(out," ");
		fprintf(out,"%ld  ", i+1);
      if (n>999)
		  fprintf(out," ");
      if (n>9999)
		  fprintf(out," ");
	 } /* for i */
	 fprintf(out,"\n");
	 fprintf(out,"Times found ");
    if (n>999)
		  fprintf(out," ");
    if (n>9999)
		  fprintf(out," ");
	 for (i=start; (i<scz2 && i<start+10); ++i)
	 {
		if (gz2[i]<10)
		  fprintf(out," ");
		if (gz2[i]<100)
		  fprintf(out," ");
		if ((n>999) && (gz2[i]<1000))
		  fprintf(out," ");
		if ((n>9999) && (gz2[i]<10000))
		  fprintf(out," ");
		fprintf(out,"%ld  ", gz2[i]);
		zaehler+=gz2[i];
	 } /* for i */
	 fprintf(out,"\n\n");
	 for (i=0; i<scz2; ++i)
	 {
		if (i<9)
		  fprintf(out," ");
		if (i<99)
		  fprintf(out," ");
		fprintf(out,"%ld  ", i+1);
                gn=smatrix[sseg(i,i)];
		if (gn<10)
		  fprintf(out," ");
		if (gn<100)
		  fprintf(out," ");
		if ((n>999) && (gn<1000))
		  fprintf(out," ");
		if ((n>9999) && (gn<10000))
		  fprintf(out," ");
		fprintf(out,"  %ld  ", gn);
		for (j=start; (j<scz2 && j<start+10); ++j)
		{
		  if (j<i+1)
        {
			 fprintf(out,"     ");
          if (n>999)
		      fprintf(out," ");
          if (n>9999)
		      fprintf(out," ");
        } /* if j */
        else
        {
           if (j<start)
             j=start;
           gn=smatrix[sseg(i,j)];
           if (gn<10)
             fprintf(out," ");
           if (gn<100)
             fprintf(out," ");
           if ((n>999) && (gn<1000))
              fprintf(out," ");
           if ((n>9999) && (gn<10000))
              fprintf(out," ");
	   fprintf(out,"%ld  ", gn);
        } /* else (j>i) */
		} /* for j */
		fprintf(out,"\n");
    } /* for i */
	 start+=10;
  } /* do */
  while (start<scz2);
  fprintf(out,"\n%ld iterations led to collinear regressors.\n",invz);
  zaehler+=invz;
  fprintf(out,"\n%ld iterations did not finish fast enough.\n",convstop);
  zaehler+=convstop;
  if (heapco)
    fprintf(out,"\n%ld iterations led to too small clusters.\n",ad+zad-zaehler);
} /* tabausgabe */

void stabausgabe(void)
/* Ausgabe der Aehnlichkeitstabelle der g2-Cluster */
/* Benoetigt globale Variable gz2, out, scz2, smatrix */
/* Veraendert globale Variable simmatrix */
/* Benoetigt Funktion sseg */
{
long i, j, gn, start=0;

  fprintf(out,"\n* Cluster similarity table *\nSimilarity measure: 2|Intersection|/(|FPC1|+|FPC2|)\n\n");
  for (i=0; i<scz2-1; ++i)
    for (j=i+1; j<scz2; ++j)
      simmatrix[sseg(j,i)]=(double) 2*smatrix[sseg(j,i)]/(smatrix[sseg(i,i)]+smatrix[sseg(j,j)]);
  do
  {
    fprintf(out,"No.  Total      ");
    for (i=start; (i<scz2 && i<start+10); ++i)
      fprintf(out,"%4ld  ", i+1);
    fprintf(out,"\n");
    fprintf(out,"Times found  ");
    fprintf(out,"  ");
    for (i=start; (i<scz2 && i<start+10); ++i)
      fprintf(out,"%5ld ", gz2[i]);
    fprintf(out,"\n\n");
    for (i=0; i<scz2; ++i)
    {
      fprintf(out,"%4ld  ", i+1);
      gn=smatrix[sseg(i,i)];
      fprintf(out," %5ld   ", gn);
      for (j=start; (j<scz2 && j<start+10); ++j)
      {
        if (j<i+1)
	  fprintf(out,"      ");
        else
        {
           if (j<start)
             j=start;
           fprintf(out,"%4.3f ",simmatrix[sseg(i,j)]);
        } /* else (j>i) */
      } /* for j */
      fprintf(out,"\n");
    } /* for i */
    start+=10;
  } /* do */
  while (start<scz2);
  if (heapco)
    fprintf(out,"\n");
} /* stabausgabe */






