/* FIXREG.C: Regression Fixed Point Clusters with grouping variable,
missing values */

/* Die Bemerkung TZ kennzeichnet nur zu Testzwecken sinnvolle Zeilen. */
/* TZ */
#ifdef dos
#include <alloc.h> /* Use only under DOS */
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#ifdef dos
#include <dos.h> /* Use only under DOS */
#endif
#include "fixdefs.h"
#include "vfm.h"
#include "lesen.h"  /* benoetigt fixglo */
#include "regstan.h" /* benoetigt standard */
#include "lssch.h" /* benoetigt matrix */
#include "clusim.h" /* benoetigt simglo */   /* NEU */

#ifdef dos  /* comment out if not compiled by make */
extern unsigned _stklen=55000; /* Use only under DOS */
#endif /* comment out if not compiled by make */

/* Grundablauf */
void settings(void);  /* NEU */
void durchlauf(long); /* Nummer */
int stop(long); /* Zaehlvariable; Ausgabe: Abbruch */

/* Rechnungen zur Iterationszahl */
double powdouble(double, double);
double qn(long); /* Clustergroesze */
long itnumber(double, long, long); /* prob, imin, nmin */
long nmin(double); /* probability */

/* Prognosebereich, Ueberpruefung und Entscheidung ueber Cluster */
int prog(void); /* Rueckgabe: Indikator 1, wenn sich etwas geaendert hat */
long vorhanden(void); /* Rueckgabe: Nummer der vorhandenen Cluster */
int progy(long); /* j */
int clgleich (long); /* Clusternr.; Rueckgabe: 1, wenn bereits vorhanden */
double multk(double); /* c */
double hk(double, double); /* c, k */

/* Verschiedene Ausgabefunktionen */
void lsausgabe(int); /* LS-Sch. i.O. oder Matrix singulaer */
long grausgabe(int); /* Ausgabestop, Rueckgabe: n2 */
void vausgabe(double d1[], long);
void rausgabe(void);
void structures(void);

FILE *out;
kvektor x[NKOR], mx, dx;
vektor th0;
/* x-Werte, Median x, Dispersion x, x transponiert x invers, theta 0 */

double sc, s, sca, my, dy, g2, ual, simcut; /* NEU */
/* Skala, Skala des Gesamtdatensatzes, Skala des Allesclusters,
Median und Dispersion
von y, Gamma 2. Durchgang,
Konstante fuer Skalenberechnung, Aehnlichkeitsgrenzwert fuer Strukturen */

double  *y, *r, *simmatrix; /* NEU */
/* y-Werte, Residuen, Aehnlichkeitsmatrix */

long ad, zad=0, imin, invz=0;
int heapco=1;
long convstop=0; /* NEU */
/* Anzahl der Durchgaenge (gewuenscht, zusaetzlich),
heapco: heap memory reicht, invz: Zaehler fuer
Abbruch wegen nicht invertierbarer Matrix,
nicht fertig iterierte Konfigurationen; imin=minimum number of findings */

long n, n2, p;
int gi[NKOR], gk[NKOR], gl[NKOR], gm[NKOR], ind2, cco, mco, rco;
long mult, scz2;
int ico, dco;
long mcg, group[NKOR], gnummer[NKOR], ngr;
int gvco, coutco;
/* n, n der aktuellen Cluster, p, i in aktuellem Cluster ?,
i in Allescluster 2 ?, Wahrscheinlichkeiten fuer Ziehung, i in relevantem Cluster ?,
ind2: 2 fuer Allescluster-Iteration, 1 fuer normale Iteration, 3 fuer manuellen
Cluster, 0, falls Allescluster in normaler Iteration gefunden (in prog auch
fuer zu kleine oder bereits vorhandene Cluster);
Manuelle Cluster, Manuelle Relevanzbeurteilung ?, c nach Formel?,
Wahrscheinlichkeitsmultiplikator, Clusterzaehler,
Standardisierte Residuen, Identifikatoren, Datenformat,
Mindestclustergroesze, 
Gruppierungsvariable
fuer Suchstart, interne Nummer der Gruppe, ngr: Zahl der Gruppen, 
Gruppierung erwuenscht? Cluster output in fix-File?*/

long  *gz2;
long  *smatrix;   /* NEU */
/* Wie haeufig wurden Level 2-Cluster gefunden? Schnittmatrix der
Cluster */

char outname[NLEN], dateiname[NLEN], id[NKOR][VLEN], varname[PKOR+3][VLEN];

static FILE *out2;

static double  *gsc2,  *gls2[PKOR];
/* Skalen der verschiedenen Cluster, LS-Schaetzer */

static long agn, d, isl, szaehler=0, sg;
static int sco, stanco, stanco1, wco;  /* NEU */
/* Iterationsnummer,
Hoechstzahl der Iterationsschritte, Laenge der smatrix,
sg: Startclustergroesze, sco: Endabfrage, Standardisierung ausgeben,
unterdruecken, Punkte mit kleinerer Wahrscheinlichkeit */

void main(void)
{
  double rand02;
  long q;
  long i, j, agroup;
  int invers;   /* NEU */
  /*  invers: 0, wenn LS-Schaetzer-Matrix singulaer, alte Gruppe */
  char co[]= "ll"; /* NEU */

/* NEU */ /* Kommentargliederung von main, Ordnung der gl. Variablen */
/*

Initialisierungen, Eingaben

*/
  y= (double *) malloc(NKOR*sizeof(double));
  r= (double *) malloc(NKOR*sizeof(double));
  eingabe();
  srand( (unsigned)time(NULL) );
/*  printf ("Free heap memory: %lu \n",coreleft());
  printf ("Stack length: %u \n",_stklen);
  fprintf (out, "Free heap memory: %lu \n",coreleft());
  fprintf (out, "Stack length: %u \n",_stklen); */
  gsc2= (double *) malloc(sizeof(double)); scz2=0;
  gz2= (long *) malloc(sizeof(long));
  smatrix= (long *) malloc(sizeof(long)); /* NEU */
  if ((y==NULL) || (r==NULL))
    printf("WARNING! y/r not allocated!\n");
  if (gsc2==NULL)
    printf("WARNING! gsc2 not allocated! \n");
  if (gz2==NULL)
    printf("WARNING! gz2 not allocated! \n");
  if (smatrix==NULL)
    printf("WARNING! smatrix not allocated! \n");
  for (i=0; i<p+1; ++i){
	 gls2[i]= (double *) malloc(sizeof(double));
	 if (gls2[i]==NULL)
		printf("WARNING! gls2 not allocated! \n");
  }
  if (gvco)
  {
	 gnummer[0]=-1;
	 j=0;
	 agroup=-2;
    while (gnummer[j]>agroup)
    {
      agroup=gnummer[j];
      for (i=0; i<n; ++i)
      {
        if (group[i]>agroup && (group[i]<=gnummer[j] || gnummer[j]==agroup))
        {
    	  gnummer[j]=group[i];
          if (gnummer[j]==agroup+1)
            i=n;
        } /* if group */
      } /* for i */
      ++j;
      gnummer[j]=gnummer[j-1];
    } /* while gnummer>agroup */
	 ngr=j-1;
  } /* if gvco */
  settings(); /* NEU */
/*

Standardisierung

*/
  if (!stanco1)
  {
    printf("Standardizing...\n\n");
    standard();
  } /* if !stanco1 */
  else
  {
     my=0; dy=1;
     for (i=0; i<p; ++i)
     {
        mx[i]=0; dx[i]=1;
     }
  }  /* else: stanco1 */
  if (stanco)
    stanausgabe();  /* NEU */ /* else gestrichen */
/*

Weitere Vorbereitungen

*/
  if (wco)
  {
    while (co[0]!='y')
    {
      printf("Enter 1: Probability decreased, 0: default \n");
      for (i=0; i<n; ++i)
      {
        if (ico)
          printf ("Value %s ", id[i]);
        else
	  printf("Value %ld ", i+1);
	scanf("%d", &gm[i]);
      }  /* for i */
      j=0;
		printf("Search probability decreased for points \n");
      for (i=0; i<n; ++i)
      {
        if (gm[i]==1)
        {
               ++j;
          if (ico)
            printf ("%11s ", id[i]);
          else
	    printf ("%ld ", i+1);
          if (j%6==0)
            printf ("\n");
        } /* if gm */
      } /* for i */
      printf ("\nCorrect ? (y/n) ");
      scanf ("%s", co);
    } /* while co[0] */
    j=0;
	 fprintf(out, "\nSearch probability decreased for points \n");
    for (i=0; i<n; ++i)
    {
      if (gm[i]==1)
		  {
		    ++j;
        if (ico)
          fprintf (out,"%11s ", id[i]);
        else
	  fprintf (out,"%ld ", i+1);
	      if (j%6==0)
          fprintf (out,"\n");
      } /* if gm */
    } /* for i */
    fprintf (out,"\n");
  } /* if wco */
  fprintf(out, "Scale constant c=%5.3f (Corresponding to standard search level=%7.5f) \n", ual*ual, 1-chi2(1,ual*ual));
  if (gvco)
    fprintf(out, "Initial grouping by %s \n",varname[p+3]);
/*

FPC-Berechnungen, Beginn

*/
  invers=lssch(x, y, n);
  if (invers)
    sca=sc=s=lsscale(x, y, th0, n);
  fprintf(out,"\nLS-estimator for the whole dataset\n");
  lsausgabe(invers);
  gl[0]=mult-((mult-1)*(gm[0]==1));
  for (i=1; i<n; ++i)
    gl[i]=gl[i-1]+1+(mult-1)*(gm[i]==0);
  fprintf(out,"1st run: Iteration start with whole dataset (WD-cluster)\n");
  for (i=0; i<n; ++i)
	 gi[i]=1;
/* TZ */ printf("WD-cluster \n \n");
  ind2=2; ++zad;
  durchlauf(-1);
  sca=sc; j=0;
  for (i=0; i<n; ++i)
  {
    gk[i]=gi[i];
    if (gi[i]==0)
	++j;
  }  /* for i */
  if (!heapco)
  {
    fprintf(out,"WARNING! Heap memory full! Program terminated.\nEnlarge minimum cluster size or scale factor to get less clusters.\n");
    goto heapend;
  }
  if (j>=sg)
  {
/* TZ */ printf("Complement of WD-cluster \n \n"); ++zad; mco=0;
    for (i=0; i<n; ++i)
	gi[i]=(!gk[i]);
    ind2=1;
    if (ind2)
      durchlauf(-1);
    if (!heapco)
    {
      fprintf(out,"WARNING! Heap memory full! Program terminated.\nEnlarge minimum cluster size or scale factor to get less clusters.\n");
      goto heapend;
    }
  } /* if j>=sg */
/*

FPC-Berechnungen: ad-Schleife

*/
  for (q=0; q<ad; ++q)
  {
/* TZ */ if ((q+1)%1000==0) printf("Algorithm run %ld of %ld \n \n", q+1, ad);
    for (i=0; i<n; ++i)
      gi[i]=0;
    n2=sg;
    for (i=0; i<sg; ++i)
    {
	  rand02= gl[n-1]* (double) rand()/RAND_MAX;
	  j=-1;
	  do
	  {
		 ++j;
	    if (rand02<=gl[j])
	      ++gi[j];
	    if (gi[j]==2)
	    {
	      --gi[j]; --i;
	    } /* if */
	  } /* do */
	  while (rand02>gl[j]);
    } /* for i */
    ind2=1; mco=0;
    if (ind2)
      durchlauf(q);
    if (!heapco)
    {
      fprintf(out,"WARNING! Heap memory full! Iterations terminated.\nEnlarge minimum cluster size or scale factor to get less clusters.\nIteration run %ld.\n",q+1);
      goto heapend;
    }
    if (sco)
	  {
      if (stop(q))
	    q=ad;
     } /* if sco */
  } /* for q */
/*

FPC-Berechnungen, Zusatzgruppen

*/
  if (gvco)
  {
    mco=1;
    for(agn=0;agn<ngr;++agn)
    {
        ++zad;
  /* TZ */ printf("Cluster iteration with group %ld \n \n", gnummer[agn]);
	fprintf(out, "* Iteration start with group %ld: *\n", gnummer[agn]);
        n2=0;
		    for (i=0; i<n; ++i)
        {
          gi[i]=(group[i]==gnummer[agn]); n2+=(group[i]==gnummer[agn]);
        } /* for i */
		    ind2=1;
        if (n2>p+1)
        {
	  if (ind2)
	    durchlauf(gnummer[agn]);
          if (!heapco)
          {
            fprintf(out,"WARNING! Heap memory full! Iterations terminated.\nEnlarge minimum cluster size or scale factor to get less clusters.\n");
            goto heapend;
          }
        } /* if n2 */
        else
          fprintf(out,"Group has too few members.\n");
          fprintf(out,"\n  ***  \n");
	 } /* for agn */
  } /* if gvco */
/*

Endausgabe

*/
heapend:
  free(y); free(r);    /* NEU */
  simmatrix= (double *) malloc(szaehler*sizeof(double)); /* NEU */
  tabausgabe();
  stabausgabe();       /* NEU */
  structures();        /* NEU */
  free(smatrix);       /* NEU */
  fclose(out);
} /* main */

double powdouble(double x, double y)
     /* x^y */
{
  return(exp(y*log(x)));
}

double qn(long nm)
     /* Approx. probability of finding of cluster of size nm */
     /* Benoetigt globale Variable n, sg */
     /* Benoetigt Funktion choose */
{
  return((double) choose(nm,sg)/choose(n,sg));
}

long itnumber(double prob, long nm, long maxit)
     /* Number of iterations for probability prob of imin findings
	for size nm */
     /* Benoetigt globale Variable n, sg, imin */
     /* Benoetigt Funktionen qbinomsi, pbinom, dbinom, choose, qn */
{
  long m1, m2, m3; double qmin, alpha;

  m1=maxit; m2=1; alpha=1-prob; qmin=qn(nm);
  if (qbinomsi(m1,qmin,alpha,imin)){
    do{
      m3=(m1+m2)/2;
      if (qbinomsi(m3,qmin,alpha,imin))      
        m1=m3;
      else m2=m3;
    }
    while((m1-m2)>1);
  }
  return(m1);
}

long nmin(double prob)
     /* Minimum size of clusters to be recovered with probability prob */ 
     /* Benoetigt globale Variable n, sg, ad, imin */
     /* Benoetigt Funktionen qbinomsi, pbinom, dbinom, choose, qn */
{
  long m1, m2, m3; double q, alpha;

  m1=n; m2=sg; alpha=1-prob; 
  do{
    m3=(m1+m2)/2;
    if (qbinomsi(ad,qn(m3),alpha,imin))      
      m1=m3;
    else m2=m3;
  }
  while((m1-m2)>1);
  return(m1);
}

void settings(void)
/* Ein- und Ausgabe der Settings */
/* Benoetigt globale Variable n, p, out */
/* Aendert globale Variable sg, ad, g1, g2, rco, mult, sco, ual, wco,
   mcg, stanco, stanco1, simcut, imin, coutco */
/* Benoetigt Funktionen Phi, phiinv, itnumber, nmin */
{
  double sf, minprob, rprob;
  long nm;
  long maxit;
  char co[]= "ll", jn[2][6], *yes="yes", *no="no";

  strcpy (jn[1], yes); strcpy (jn[0], no);
  sg=p+2; imin=3; minprob=0.95; rprob=0.5; nm=floor((double) n/5.0 + 0.5); 
  maxit=200000;
  ad=itnumber(minprob,nm,maxit); 
  g2=2-2*Phi(sqrt(10)); rco=0; mult=1; sco=0; cco=1; coutco=0;
  ual=sqrt(3+33/powdouble(n*powdouble(2,(double) -(p-1)/2.0),(double) 1/3)+2900000/powdouble(n*powdouble(2,(double) -(p-1)/2.0),3));
  /*  printf("pow1= %15.7lf 2hpd= %15.7lf pow2= %15.7lf\n",powdouble(n*powdouble(2,(double) -(p-1)/2.0),1/3),powdouble(2,(double) -(p-1)/2.0),powdouble(n*powdouble(2,(double) -(p-1)/2.0),3)); */
  mcg=nmin(rprob); 
  stanco=0; wco=0; stanco1=0; simcut=0.85;
  isl=n;
  if (n>5000)
    isl=5000;
  while (co[0]!='q')
  {
	 printf("\n\nSettings for cluster search:\n (*) indicates test functions for curious users; possibly unstable or useless.\n");
	 printf("       a) %ld runs with random start (choose a for direct change),\n", ad);
	 printf("       b) Change of iteration number through parameters\n           minimum size %ld of FPC to be found with probability %5.3f\n           maximum iteration number %ld\n",nm,minprob,maxit);
         printf("       c) Scale factor c determined by approximation formula: %s\n", jn[cco]);
	 printf("       d) Scale factor c = %5.3f\n", ual*ual);
         if (!cco)
	   printf("       e) Standard level %7.5f (=>Scale factor c %5.3f)\n", 2*(1-Phi(ual)), ual*ual);
     printf("       f) (*) Number of data points for search start: %ld \n",sg);
	 printf("       g) Minimum size of clusters: %ld \n", mcg);
	 printf("       h) Output of standardized values (median and MAD): %s \n",jn[stanco]);
	 printf("       i) Minimum times to be found for relevant FPC: %ld \n",imin);
	 printf("       j) (*) Do you want to enter points with decreased search probability: %s \n",jn[wco]);
     printf("       k) Suppress standardization: %s\n",jn[stanco1]);
     printf("       l) Iteration step limit: %ld\n",isl);
     printf("       m) Similarity cutoff for FPC-groups: %5.4f\n",simcut);  /* NEU */
     printf("       n) Point numbers output in fix-file: %s\n",jn[coutco]);
    printf("       q) Start of calculations\n\
Enter a letter, if you want to change the default settings\n");
	 scanf ("%s", co);
	 switch (co[0])
	 {
	   case 'a':
	     printf("Number of search runs ");
	     scanf("%ld", &ad); break;
	   case 'b':
	     printf("Minimum size to be found with high probability: ");
	     scanf("%ld", &nm);
	     printf("Probability for FPC with this size: ");
	     scanf("%lf", &minprob); 
	     printf("Maximum iteration runs: ");
	     scanf("%ld", &maxit);
	     ad=itnumber(minprob,nm,maxit); break;
	   case 'c':
	     cco=!cco;
	     if(!cco)
	       ual=(phiinv (1-g2/2));
	     else
	       ual=sqrt(3+33/powdouble(n*powdouble(2,(double) -(p-1)/2.0),(double) 1/3)+2900000/powdouble(n*powdouble(2,(double) -(p-1)/2.0),3));
	     break;
	   case 'd':
	     printf("Scale factor c for standard level: ");
	     scanf("%lf", &sf);
	     ual=sqrt(sf);
	     cco=0;
	     break;                                         /* NEU */
           case 'e':
	     printf("Standard level: ");
	     scanf("%lf", &g2);
	     ual=phiinv (1-g2/2);
	     break;
           case 'f':
	     printf("Number of data points for search start: ");
	     scanf("%ld", &sg); break;
	   case 'g':
	     printf ("Minimum cluster size: ");
	     scanf ("%ld", &mcg); break;
           case 'h':
	     stanco=!stanco; break;
	   case 'i':
	     printf ("Minimum times found to be relevant: ");
	     scanf ("%ld", &imin); break;
           case 'j':
	     wco=!wco; break;
           case 'k':
             stanco1=!stanco1; break;
           case 'l':
	     printf("Iteration step limit: ");
	     scanf("%ld", &isl); break;
           case 'm':            /* NEU */
	     printf("Similarity cutoff for FPC-groups: ");  /* NEU */
	     scanf("%lf", &simcut); break;                         /* NEU */
           case 'n':
             coutco=!coutco; 
    } /* switch co */
  } /* while co!=q */
  fprintf(out,"\n\nSettings for cluster search:\n");
  fprintf(out,"        a) %ld runs,\n", ad);
  fprintf(out,"        f) Number of data points for search start: %ld \n", sg);
  fprintf(out,"        g) Minimum size of clusters: %ld \n",mcg);
  fprintf(out,"        i) Minimum times found to be relevant: %ld \n",imin);
  fprintf(out,"        j) Do you want to enter points with decreased search probability: %s \n",jn[wco]);
  fprintf(out,"        l) Iteration step limit: %ld\n",isl);  /* NEU */
  fprintf(out,"        m) Similarity cutoff for FPC-groups: %5.4f\n\n",simcut);  /* NEU */
  if (stanco1)
    fprintf(out,"No standardization!\n\n");
} /* settings */

int stop(long q)
/* Bricht Verfahren ab, falls nach je 20 Durchgaengen gewuenscht */
/* Benoetigt globale Variablen n, gm */
{
long i, j;
char co[2];

  if ((q%20)==1)
  {
    j=0;
    for (i=0; i<n; ++i)
      if (gm[i]>0)
	j++;
    printf("%ld values in relevant clusters (n=%ld). Do you want to stop the search ? (y/n) ", j, n);
    scanf("%s", co);
    return(co[0]=='y');
  }
  else
    return(0);
}  /* stop */

void durchlauf(long q)
/* Eine Clusteriteration */
/* Benoetigt globale Variable x, y, n, p, g1, g2, out, mco, rco, mult, heapco, d */
/* Veraendert globale Variable n2, gi, gj, gk, gl, gm, sc, th0, r, ind2, convstop, isl */
/* Benoetigt Funktionen grausgabe, vg, lssch, lsscale, prog, vorhanden */
/* Benoetigt NKOR */
{
kvektor xa[NKOR];
double ya[NKOR];
long i;
int ind3, invers=0;
/* ind3: 1, wenn weiteriteriert werden soll, invers: LS-Schaetzer i.O.? */

  d=0;
  n2=grausgabe(q>=-1);
  do
  {
    ++d;
    if ((d>isl) && (d>1))
    {
        ind3=0;
	fprintf(out,"* Algorithm did not converge fast enough.\n Case information file gets number n%ld.\n",convstop+1);
	fprintf(out,"* The actual configuration contains %ld points. Parameters:\n", n2);
        lsausgabe(invers);
        fprintf(out,"\n  ***  \n");
        ++convstop;
        rausgabe();
        goto dcend;
    } /* if d>isl */
    n2=0;
    for (i=0; i<n; ++i)
    {
      if (gi[i]==1)
      {
        ya[n2]=y[i];
	vg(xa[n2],x[i],p);
	++n2;
      } /* if gi[i]==1 */
    } /* for i */
    invers=lssch(xa, ya, n2);
    if (invers)
	    sc=lsscale(xa, ya, th0, n2);
    else
    {
	  ind3=0;
	  ++invz;
	  if (mco)
	      fprintf(out, "* Regressors not invertable during iteration *\n  *** \n\n");
      } /* if !invers */
    if(invers)
      {
	      ind3=prog();
              if (!heapco)
		ind3=0;
      } /* if invers */
  } /* do */
  while (ind3);
dcend:
  return;
} /* durchlauf */

void rausgabe(void)
/* Schreibt die Residuen der standardisierten Werte formatiert in die Ausgabedatei */
/* Benoetigt globale Variable n, out, gi, r, ico, gvco, ngr, ig, group, gnummer, scz2, outname, d, isl, convstop */
/* Veraendert globale Variable out2 */
{
  long i, j, gzaehler[NKOR], gztotal[NKOR];
  char outname2[NLEN], addi[6];

  strcpy(outname2, outname);
  if (d>isl)
    sprintf(addi, ".n%ld", convstop);
  else
    sprintf(addi, ".%ld", scz2);
  strcat(outname2,addi);
  if((out2=fopen(outname2,"w"))==NULL)
  {
		  printf("Error: Opening of output file impossible. \n");
        exit(0);
  }/*  if out2 */
  if (d>isl)
    fprintf(out2,"Case information for not fully iterated cluster %ld\n", convstop);
  else
    fprintf(out2,"Case information for cluster no. %ld\n",scz2);
  for (i=0; i<ngr; ++i)
  {
    gzaehler[i]=0;
    gztotal[i]=0;
  } /* for i */
  if (ico)
    fprintf(out2,"\n%s - ",varname[0]);
  if (gvco)
    fprintf(out2,"%s - ",varname[p+3]);
  fprintf(out2, "residual of standardized value - cluster indicator\n");
/* TZ   printf("Test\n");*/
/* TZ   fprintf(out,"Test\n"); */
  for (i=0; i<n; i++)
  {
	if (ico)
	  fprintf(out2, "%12s   ",id[i]);
   if (gvco)
   {
     fprintf(out2, "%5ld  ",group[i]);
     for (j=0; j<ngr; ++j)
     {
            if (group[i]==gnummer[j])
              ++gztotal[j];
     }  /* for j */
   } /* if gvco */
   fprintf(out2, "%14.7g  %d\n", r[i],gi[i]);
   if (gi[i] && gvco)
   {
          for (j=0; j<ngr; ++j)
          {
            if (group[i]==gnummer[j])
              ++gzaehler[j];
          }  /* for j */
   } /* if gi[i] & gvco */
  }  /* for i */
/*  fclose(out2); */
  if (gvco)
  {
    fprintf(out2, "\n%s - number of cases from %s in cluster\n",varname[p+3],varname[p+3]);
    for(j=0; j<ngr; ++j)
      fprintf(out2, "   %ld   %ld (of %ld)\n",gnummer[j],gzaehler[j],gztotal[j]);
  } /* if gvco */
  fclose(out2);
}  /* rausgabe */

void vausgabe(double vek[], long n)
/* Schreibt den Vektor vek formatiert in die Ausgabedatei */
/* Benoetigt globale Variable out */
{
  long i;

  for (i=0; i<n; i++)
  {
	fprintf(out, "%15.10f ", vek[i]);
	if (i%5==4)
	  fprintf(out, "\n");
  }
  fprintf(out, "\n");
} /* vausgabe */

void lsausgabe(int invers)
/* Ausgabe des LS-Schaetzers */
/* Benoetigt globale Variable sc, p, out, mx, dx, my, dy */
/* Veraendert globale Variable th0 */
/* Benoetigt Funktionen vausgabe, vresid, vg, restandard */
{
vektor ths;
long i;

  if (invers)
  {
	 fprintf(out,"\nLS-estimator\n");
	 vresid(x, y, th0, n);
	 vg (ths, th0, p+1);
	 restandard(th0);
	 fprintf (out, "indep. variable   coeffizient    standardized coeff.\n");
	 for (i=0; i<p; ++i)
	 {
		fprintf(out,"%11s      ", varname[i+2]);
		fprintf(out,"%16.11f %16.11f\n",th0[i],ths[i]);
	 }
	 fprintf (out, "constant         %16.11f\n",th0[p]);
	 fprintf(out,"\nSquared scale estimator: %10.6f, bias-corrected: %10.6f \n",dy*dy*sc, dy*dy*sc*multk(ual));
	 fprintf(out,"\n");
  }
  else
    fprintf(out,"\nLS-estimator not computed because of singular matrix.\n\n");
} /* lsausgabe */

/* Modul PROG */

int prog(void)
/* Berechnung des Ausreiszeridentifikators */
/* Benoetigt globale Variable x, y, n, p, g1, g2, out, rco, mult, sc, sca, th0, mcg, dx, dy, mx, my, heapco, ual */
/* Veraendert globale Variable n2, gi, gj, gk, gl, gm, ind2, r, scz2, gz2, gsc2 */
/* Benoetigt Funktionen resid, vresid, rausgabe, phiinv, grausgabe, progy, lsausgabe, chi2, Phi, vorhanden, vg, restandard */
/* Benoetigt M_PI, MGG */
{
  double q1, q2;
  long i, j;
  int ind, ind1, ind3, outco;
  /* ind: 0, falls Iteration fertig; ind1: 1, falls Cluster relevant und nicht
     Allescluster; ind3: 1, falls Cluster bereits vorhanden */
  char co[2];

  ind=0;
  ind1=(ind2!=2);
  resid(x, y, th0, n);
  for (i=0; i<n; ++i)       /* Neuer Cluster: wer gehoert dazu ? */
  {
    if (gi[i]==0)
	  {
      gi[i]=progy(i);
      if (gi[i]!=0)
		  {
	      ind=1;
	      ++n2;
      } /* if gi[i]!=0 */
    } /* if gi[i]==0 */
    else
    {
      gi[i]=progy(i);
      if (gi[i]==0)
      {
	      ind=1;
	      --n2;
      } /* if gi[i]==0 */
    } /* else (gi[i] sofort !=0) */
  } /* for i */
  if (!ind)                 /* Nichts hat sich veraendert */
  {
    outco=(n2>=mcg);
    if (mco && (!outco))
		fprintf(out,"* Iteration led to too small cluster *\n  *** \n\n");
    ind2=0;               /* ind2=0: Iteration wird nicht fortgesetzt. */
    for (i=0; i<n; ++i)
    {
	      if (gi[i]!=gk[i]) /* g2-Cluster!=Allescluster */
	        ind2=1;
     }  /* for i */
     if (!ind2)          /* g2-Cluster==Allescluster */
     {
	      ++gz2[0];
	      if (mco)
	        fprintf(out, "* Iteration led to WD-cluster. *\n  *** \n\n");
     } /* if !ind 2 */
    if (ind2 && outco)
    {              /* Brauchbarer Cluster != Allescluster gefunden */
      ind3=vorhanden();
      if (heapco)
      {
        if (ind3)    /* Iteration wird gestoppt */
	      ind2=0;
        if (!ind3)   /* Cluster neu! */
        {
	   fprintf(out," \n");
	   fprintf(out,"Successful run. \n");
	   fprintf(out, "\nOutput of standard level-cluster no. %ld:\n",scz2);
	   lsausgabe(1);
           fprintf(out,"Corresponding outlier region: absolute residual> %15.4lf;\n",ual*dy*sqrt(sc));
           fprintf(out,"                 absolute standardized residual> %15.4lf\n",ual*sqrt(sc));
        } /* if (!ind3) */
      } /* if heapco */
      else
        goto progend;
    } /* if ind2 && outco */
    if (ind2)
    {
      ind1=1;
      if (rco)
      {
	      printf ("Cluster found ! Contains the following points: \n");
	      j=0;
	      for (i=0; i<n; ++i)
	      {
		      if (gi[i]!=0)
		      {
		        if (ico)
		          printf("%11s ", id[i]);
		        else
			  printf("%8ld ", i+1);
		        j++;
		        if (j%6==0)
		          printf("\n");
		      } /* ig gi[i]!=0 */
	      } /* for i */
	      printf("\n");
	      printf("Number of points: %ld\n", n2);
	      printf("Cluster quality against whole dataset: %11.7f\n",q1);
	      if (ind1)
            printf("Cluster quality against WD-cluster: %11.7f\n", q2);
	      printf("Is this cluster relevant ? (y/n)");
	      scanf("%s", co);
	      ind1=(co[0]=='y');
	      printf("Residuals to output file ? (y/n)");
	      scanf("%s", co);
	      if (co[0]=='y')
	        rausgabe();
      } /* if rco */
      else
      {
	      ind1=outco; /* Cluster gross genug fuer Ausgabe ? */
	      if (ind1)
		     rausgabe();
      } /* else (!rco) */
      if (ind1) /* Justierung der Multiplikatoren: Punkt in Cluster => Geringere Auswahlwahrscheinlichkeit */
      {
	      if (n2<=n-2*(p+3))
	      {
	        if (gl[0]!=1)
	          gl[0]-=((mult-1)*(gi[0]==1));
	        for (i=1; i<n; ++i)
	        {
	          if (gi[i]==1)
	            gm[i]=1;
	          gl[i]=gl[i-1]+1+(mult-1)*(gm[i]==0);
	        } /* for i */
	      } /* if n2 klein */
      } /* if ind1 */
    } /* ind2 */
  } /* if !ind */
  if (outco)
  {
      n2=grausgabe(ind);
      if (ind2 && (!ind))
        fprintf(out,"\n  ***  \n");
  } /* if outco */
progend:
  return (ind);
} /* prog */

long vorhanden(void)
/* Nummer des Clusters, die gefunden wurde, falls schon vorhanden; anderenfalls
Eintrag in smatrix */
/* Veraendert globale Variablen gz1, gz2, gsc1, gsc2, gls, scz2, heapco, smatrix */
/* Benoetigt globale Variable ual, sc, th0, szaehler */
/* Benoetigt Funktionen clgleich, resid, progy, sseg */
{
  long ind, i, j, k, gn;
  int test;
  double ssim;
  vektor thsim;

  ind=0;
  for (i=0; i<scz2; ++i)
  {
     if (clgleich(i))
     {
	 ind=i+1;
	 ++gz2[i];
	 i=scz2;
	 if (mco)
       fprintf(out,"* Iteration led to standard level-cluster no. %ld. *\n  *** \n\n",ind);
       } /* if clgleich2 */
    } /* for i */
    if (!ind)
    {
       ++scz2;
       if (scz2%20==1)
       {
	 gsc2= (double *)realloc(gsc2, (1+scz2/20)*20*sizeof(double));
	 gz2= (long *)realloc(gz2, (1+scz2/20)*20*sizeof(long));
	 test=1;
	 if ((gsc2==NULL) || (gz2==NULL))   /* NEU */
	 {
	   if (gsc2==NULL)
	     printf("WARNING! gsc2 not allocated (20)! \n");
	   if (gz2==NULL)
	     printf("WARNING! gz2 not allocated (20)! \n");
	   test=0;
	 }
	 for (i=0; i<p+1; ++i)
	 {
	   gls2[i]= (double *)realloc(gls2[i], (1+scz2/20)*20*sizeof(double));
	   if (gls2[i]==NULL)
	   {
	     printf("WARNING! gls2 not allocated (20)! \n");
	     test=0;
	   }
	 } /* for i */
	 if (test)
	 {
	   gsc2[scz2-1]=sc;
	   for (i=0; i<p+1; ++i)
	     gls2[i][scz2-1]=th0[i];
	   for (j=scz2; j<scz2+20; ++j)
	     gz2[j-1]=1;
	 } /* if test */
	 else
	 {
            heapco=0;
            --scz2;
	 } /* else (!test) */
       } /* if scz2%20==1 */
       else
       {
	   gsc2[scz2-1]=sc;
	   for (i=0; i<p+1; ++i)
	     gls2[i][scz2-1]=th0[i];
       } /* else (scz2%20!=1) */
       szaehler+=scz2; /* NEU */  /* folgender Block */
       smatrix= (long *)realloc(smatrix, szaehler*sizeof(long));
       test= (smatrix!=NULL);
       if (test)
       {
/* TZ  fprintf(out,"n2= %ld\n", n2); */
         smatrix[sseg(scz2-1,scz2-1)]=n2;
         ssim=sc;
         for (i=0; i<scz2-1; ++i)
         {
           gn=0;
           for (k=0; k<=p; ++k)
             thsim[k]=gls2[k][i];
           sc=gsc2[i];
           resid(x, y, thsim, n);
           for (k=0; k<n; ++k)
             gn+=(gi[k] && (gi[k]==progy(k)));
/* TZ    fprintf(out, "gn= %ld,  sseg(%ld, %ld)= %ld\n", gn, scz2-1, i, sseg(scz2-1,i)); */
           smatrix[sseg(scz2-1,i)]=gn;
         } /* for i */
         sc=ssim;
       } /* if test */
       else
       {
         heapco=0;
         --scz2;
       } /* else (!test) */
     } /* if !ind */ /* NEU */ /* Ende */
  return(ind);
} /* vorhanden */

long grausgabe(int ind)
/* Ausgabe des aktuellen Clusters in die Ausgabedatei */
/* Benoetigt globale Variable n, gi, out, ind2, ico, id, coutco */
{
  long i, j;
  int gra;

  gra=(ind2) && (!ind);
  if (gra && coutco)
    fprintf (out, "\nCluster contains points\n");
  j=0;
  for (i=0; i<n; ++i)
  {
    if (gi[i]!=0)
    {
      if (gra && coutco)
		{
	if (ico)
	  fprintf(out, "%11s ", id[i]);
	else
	  fprintf(out, "%4ld ", i+1);
      } /* if gra */
      j++;
      if (j%6==0)
      {
	if (gra && coutco)
	  fprintf(out, "\n");
      }  /* if j%6==0 */
    } /* if gi[i]!=0 */
  } /* for i */
  if (gra)
  {
    fprintf(out, "\nCluster contains %ld points", j);
    fprintf(out, "\n");
  }  /* if gra */
  return(j);
} /* grausgabe */

int progy(long i)
/* Ist Wert i Ausreiszer oder nicht ? */
/* Benoetigt globale Variable ual, x, y, n, p, sc, th0, r */
{
  return(sqrt(r[i])<=ual*sqrt(sc));
} /* progy */

double multk (double c)
/* Iteration des Multiplikators fuer konsistente Skala */
/* Benoetigt globale Variable ual */
/* Benoetigt Funktionen Phi, hk */
{
  double a, b, k;

  if (ual==0)
	 return(1);
  a=0.01; b=1;
  if (hk(c,a)<=0)
    return(1/a);
  do
  {
    k=(a+b)/2;
    if (hk(c,k)<0)
      b=k;
    else
      a=k;
  }
  while (fabs(b-a)>1e-9);
  return(1/k);
} /* multk */


double hk (double c, double k)
/* Funktion h(k) */
/* Benoetigt M_PI */
/* Benoetigt Funktion Phi */
{
  double x, phi;

  x=c*sqrt(k);
  phi=exp(-x*x/2)/sqrt(2*M_PI);
  return (1-k-2*x*phi/(Phi(x)-Phi(-x)));
}  /* hk */

int clgleich (long nr)
/* 1, wenn th0==gls1/2, sc==gsc1/2 */
/* Benoetigt globale Variable th0, sc, p, gls1/2, gsc1/2, g1/2 */
{
long i,j;

  j=1;
  if (gsc2[nr]!=sc)
      j=0;
  for (i=0; i<p+1; ++i)
  if (th0[i]!=gls2[i][nr])
        j=0;
  return(j);
}  /* clgleich */

void structures(void)
/* Ausgabe der simcut-Single Linkage-Cluster der g2-Cluster */
/* Benoetigt globale Variable gz2, out, scz2, simcut, smatrix, simmatrix */
/* Benoetigt Funktion sseg, qn */
{
long *struc, i, j, stn, fpc, sm, sf, cni, maxnum;
double sfmax, *simmin, *simmax;

  struc= (long *) malloc(scz2*sizeof(long));
  simmin= (double *) malloc(scz2*sizeof(double));
  simmax= (double *) malloc(scz2*sizeof(double));
  if (simmax==NULL)
  {
    fprintf(out,"WARNING! Heap memory full! No evaluation of groups.\n");
    goto simend;
  }
  for (i=0; i<scz2; ++i)
  {
    struc[i]=0; simmin[i]=1; simmax[i]=0;
  }
  stn=fpc=0;
  do
  {
    ++stn;
    do
    {
      sm=0;
      struc[fpc]=stn;
      for (i=1; i<scz2; ++i)
      {
        if(!struc[i] && (simmatrix[sseg(i,fpc)]>=simcut))
        {
          struc[i]=stn;
          if (!sm)
            sm=i;
	}  /* if */
      } /* for i */
      if (sm)
        fpc=sm;
    } /* do (fpc) */
    while (sm);
    fpc=-1;
    for (i=0; i<scz2; ++i)
      if (!struc[i])
      {
        fpc=i;
        i=scz2;
      }  /* if */
    for (i=0; i<scz2; ++i)
      for (j=i+1; j<scz2; ++j)
      {
        if (((struc[i]==stn)!=(struc[j]==stn)) && (simmatrix[sseg(i,j)]>simmax[stn-1]))
          simmax[stn-1]=simmatrix[sseg(i, j)];
	if (((struc[i]==stn) && (struc[j]==stn)) && (simmatrix[sseg(i,j)]<simmin[stn-1]))
	  simmin[stn-1]=simmatrix[sseg(i, j)];
      } /* for j */
  } /* do (stn) */
  while (fpc+1);
  fprintf(out,"\n* FPC-groups *\n\n");
  fprintf(out,"Groups of FPCs represent roughly\n");
  fprintf(out,"the same pattern in the dataset. \n");
  fprintf(out,"Mathematically, they form a Single Linkage-partition of the FPCs\n");
  fprintf(out,"w.r.t. the similarities given above and cutoff value %5.4lf. \n",simcut);
  fprintf(out,"The importance of the groups can be measured by the number of\n");
  fprintf(out,"'times found'.\n");
  fprintf(out,"Each group can be typically represented by its most often found FPC.\n");
  for (i=1; i<=stn; ++i)
  {
    sf=cni=sfmax=maxnum=0;
    fprintf(out, "\nGroup %ld consists of FPCs no.\n  ", i);
    for (j=0; j<scz2; ++j)
      if (struc[j]==i)
      {
        sf+=gz2[j]; ++cni;
	/*	fprintf(out,"ER %ld= %8.5lf \n",j+1,gz2[j]/(qn(smatrix[sseg(j,j)])*ad)); */
        if (gz2[j]/(qn(smatrix[sseg(j,j)])*ad)>sfmax)
        {
          sfmax=gz2[j]/(qn(smatrix[sseg(j,j)])*ad);
          maxnum=j;
        } /* if gz2[j] */
        if (cni==11)
        {
          cni=1; fprintf(out,"\n ");
        }    /* if cni */
	fprintf(out,"%5ld", j+1);
      } /* if struc[j]==i */
    fprintf(out,"\n FPCs of group %ld were found %ld times. \n ",i, sf);
    if (sf>=imin){
      fprintf(out,"FPC no. %ld is typical for group %ld. \n ",maxnum+1, i);
      fprintf(out,"Expectation ratio is %8.5lf.\n ", sf/(qn(smatrix[sseg(maxnum,maxnum)])*ad));
/* TZ     fprintf(out,"%ld %ld\n ",smatrix[sseg(maxnum,maxnum)],ad); */
      fprintf(out,"Minimum similarity within group %ld is %5.4lf.\n ", i, simmin[i-1]);
      fprintf(out,"Maximum similarity between group %ld and any other is %5.4lf.\n ", i, simmax[i-1]);
    } /* if sf >= imin */
    else
      fprintf(out,"NOT A RELEVANT GROUP; FOUND TOO SELDOM! \n");
  } /* for i */
  simend:
  printf("\n");
}




