#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include "lesen.h"
#include "fixglo.h"

static long nold;
static char dateititel[80];

void eingabe(void)
/* Eingaben und Initialisierungen fuer Anwendungsprogramm */
/* Veraendert globale Variable gvco, dco, ico, out, dateiname, outname */
/* Benoetigt globale Variable varname, dateititel, n, p */
/* Benoetigt Funktion lesen */
/* Benoetigt NLEN, NKOR, PKOR */
{
  char co[]="ll", xx, outname2[NLEN], addi[NLEN];

  printf("\n\n\n\n\n\n\n\n\n\n");
  printf("\n \n Fixed Point Clusters for regression data, June 2001\n\n");
  printf("(c) Christian Hennig, Institut fuer Mathematische Stochastik, \n\
          Bundesstr. 55, D-20146 Hamburg, Germany, hennig@math.uni-hamburg.de\n\n");
  printf("For theoretical explanation see: Hennig, C.: 'Regression Fixed \n\
	  Point Clusters: Motivation, Consistency and Simulations Analysis\n\
	  Preprint No. 2000-02, Fachbereich Mathematik - SPST, \n\
	  Universitaet Hamburg, Bundesstrasse 55, D-20146 Hamburg, Germany, \n\
	  and in Rizzi, Vichi, and Bock (eds.): Advances in Data Science and \n\
	  Classification, pp. 37-42, Springer 1998\n");
  printf("Maximum number of data points: %d \nMaximum number of independent variables: %d \n", NKOR, PKOR-1);
	printf("Maximum length of variable names and identificators: %d \n\
    To change these values, change NKOR, PKOR, and VLEN in fixdefs.h \n\
    of the source code and compile again. \n\
    Some compilers and systems pose strong memory restrictions! \n\
    NKOR=600, PKOR=5 need e.g. approximately 50kByte stack space. \n\
    Press 'Enter' to continue.",VLEN);
  scanf ("%c", &xx);
  printf("Format of files: Separation of values with \n\
    blanks or car. return (possibly more than one). \n\
	  Scientific notation and inclusion of variables not used in the \n\
	  calculations is possible.\n\n");
  printf ("Missing values have to be indicated by a single character (no number) \n\
	   The program excludes missing values casewise. \n\
	   n has to be specified including the cases with missing values. \n\n");
  printf ("Example for format option 2 (see below):\n \
	   Test data\n \
	   3 1\n \
	   Value1 0.993 1.12\n \
	   Value2 24.655 1.17\n \
	   Value3 12.17 6.99e-1\n  \
	    (Id.) (y)   (x)\n\n \
	  Choose your file format: \n \
	  1: Data starts with 1st line, manual input of n, p\n \
	  2: 1st line head, \n    \
	     2nd line number of data points n, number of indep. variables p \n \
	  3: 1st line head, manual input of n, p\n");
  scanf("%d", &dco);
  printf("Data read from file (max. %d letters): ", NLEN);
  scanf("%s", dateiname);
  printf("Read an identificator variable (value length max. %d) ? (y/n) ", VLEN);
  scanf ("%s", co);
  ico=(co[0]=='y');
  printf ("Use a grouping variable for iteration starts ? (y/n) ");
  scanf ("%s", co);
  gvco=(co[0]=='y');
  lesen (dateiname);
  printf("Output to file (max. %d letters; NO SUFFIX!) ", NLEN);
  scanf ("%s", outname);
  printf ("General output to file %s.fix \n", outname);
  printf("Separate files for cluster case information: %s.number \n", outname);
  strcpy(outname2, outname);
  sprintf(addi, ".fix");
  strcat(outname2,addi);
  if ((out=fopen(outname2,"w")) == NULL)
  {
    printf("Error: Opening of output file impossible. \n");
    exit(0);
    printf("\n\n");
  }
  fprintf(out,"Fixed Point Clusters for regression data, (c) Christian Hennig 1998\n");
  fprintf(out,"%s\n",dateiname);
  if (dco!=1)
    fprintf(out,dateititel);
  fprintf(out,"\nn= %ld, p= %ld \n",n,p);
  if (nold>n)
    fprintf(out,"n including cases with missing values: %ld \n", nold);
  fprintf(out,"Name of the dependent variable: %s\n",varname[1]);
}

void lesen (char dateiname[NLEN])
/* Diese Funktion liest aus der Datei "Dateiname" die Werte in n, p, x, y */
/* Veraendert globale Variable id, x, y, p, n, dateititel, varname, group, nold */
/* Benoetigt globale Variable ico, dco, gvco */
/* Benoetigt NLEN, VLEN */
{
FILE *datei;
char missing[2], eingabe[NLEN], co[2];
long i, j, k, l;
int cco, c2co;
long q, buf, pos[PKOR+3], miss;

  if ((datei = fopen(dateiname, "r")) == NULL)
  {
	 printf ("Opening error "); exit(0);
  }
  switch (dco)
  {
    case 2:
	   fgets(dateititel, 80, datei);
	   fscanf(datei, "%ld %ld", &n, &p);
	   printf("\n%s \nn= %ld p= %ld \n", dateititel, n, p); break;
    case 3:
	   fgets(dateititel, 80, datei);
	   printf("\n%s \n", dateititel);
           printf("n= ");
	   scanf ("%ld", &n);
	   printf("p= ");
	   scanf ("%ld", &p); break;
    default:
      printf("n= ");
      scanf ("%ld", &n);
      printf("p= ");
      scanf ("%ld", &p);
  }  /* switch */
  nold=n;
  cco=1;
/*  for (i=0; i<PKOR+20; ++i)
    pos[i]=-1; */
  while (cco)
  {
    printf ("\nTotal number of variables in the input file: ");
    scanf ("%ld", &q);
    printf ("Input of variable names (MAX. %d LETTERS) and positions\n", VLEN);
    printf ("('Position' counts variables, not characters)\n");
    if (ico)
    {
      printf ("Name of identificator variable  ");
      scanf ("%s", varname[0]);
      printf ("Position from the left ? ");
      scanf ("%ld", &buf);
      pos[0]=buf-1;
    }
    printf ("Name of dependent variable  ");
    scanf ("%s", varname[1]);
    printf ("Position from the left: ");
    scanf ("%ld", &buf);
    pos[1]=buf-1;
    for (i=2; i<p+2; ++i)
    {
      printf ("Name of independent variable %ld ", i-1);
      scanf ("%s", varname[i]);
      printf ("Position from the left of independent variable %ld:  ", i-1);
      scanf ("%ld", &buf);
      pos[i]=buf-1;
    }
    if (gvco)
    {
      printf ("Name of grouping variable (values must be integer >= 0!) ");
      scanf ("%s", varname[p+3]);
      printf ("Generation of grouping variable by case number? (y/n)");
      scanf ("%s", co); cco=(co[0]=='y'); c2co=cco;
      while (c2co)
      {
       	i=0; j=1;
        while (i<n)
        {
	  printf("Group %ld from case %ld to case ",j,i+1);
	  scanf ("%ld", &k);
          for (l=i; l<k; ++l)
	        if (l<n)
	          group[l]=j;
	  ++j; i=k;
        } /* while i<n */
	printf("%ld groups generated. Correct? (y/n)",j-1);
        scanf ("%s", co); c2co=(co[0]=='n');
      } /* while c2co */
      if (!cco)
      {
	      printf ("Position from the left of grouping variable:  ");
	      scanf ("%ld", &buf);
	      pos[p+3]=buf-1;
      } /* if !cco */
      else
        pos[p+3]=q+1;
    } /* if gvco */
    printf ("Character indicating missing values: ");
    scanf ("%s", missing);
    printf ("Everything correct ? (y/n)");
    scanf ("%s", co); cco=(co[0]=='n');
  }
  printf ("Reading data...\n\n");
  n=0;
  for (i=0; i<nold; ++i)
  {
    miss=0;
	  for (j=0; j<q; ++j)
	  {
	     fscanf(datei, "%s", eingabe);
       if (pos[p+3]==j)
       {
         if (eingabe[0]!=missing[0])
	   sscanf (eingabe, "%ld", &group[n]);
         else
           miss=1;
       }  /* if pos */
       if (ico && (pos[0]==j))
         sscanf (eingabe, "%s", id[n]);
       if (pos[1]==j)
       {
	 if (eingabe[0]!=missing[0])
	   sscanf (eingabe, "%lf", &(y[n]));
	 else
	   miss=1;
       }  /* if pos */
       for (k=2; k<p+2; ++k)
       {
         if (pos[k]==j)
         {
           if (eingabe[0]!=missing[0])
	           sscanf (eingabe, "%lf", &(x[n][k-2]));
           else
             miss=1;
         }  /* if pos */
       } /* for k */
	  } /* for j */
    if (!miss)
      ++n;
  } /* for i */
  fclose (datei);
}
