#include <math.h>
#include <stdio.h>
#include <string.h>
#include "standard.h"

double finde (double a2[], long n, long k)
/* Findet den k. hoechsten Wert aus n in a2. */
/* Benoetigt NKOR */
{
  long l, r, i, j;
  double a3[NKOR], w, xx;

  l=0;
  for (i=0; i<n; ++i)
    a3[i]=a2[i];
  r=n-1;
  while (l<r)
  {
	xx=a3[k-1]; i=l; j=r;
	do
	{
	  while (a3[i]<xx)
		++i;
	  while (xx<a3[j])
		--j;
	  if (i<=j)
	  {
		w=a3[i]; a3[i]=a3[j]; a3[j]=w; ++i; --j;
	  }
	}
	while ((j>=i) && (j!=k-2) && (i!=k));
	if (j<k-1)
	  l=i;
	if (k-1<i)
	  r=j;
  }
  return (xx);
}

double median (double a[], long n)
/* Median des n-Werte-Vektors a */
/* Benoetigt Funktion finde */
{
  if (n%2 == 0)
	return((finde(a, n, n/2)+finde(a, n, n/2+1))/2);
  else
	return(finde(a, n, n/2+1));
}

double disp (double xy[], long n)
/* Benoetigt Funktionen median, finde */
/* Dispersion des n-Werte-Vektors a */
/* Benoetigt NKOR */
{
  double abxy[NKOR];
  long i;

  for (i=0; i<n; ++i)
	abxy[i]=fabs(xy[i]-median(xy,n));
  return(1.4826*median(abxy,n));
}


